#!/usr/bin/perl
#
# LightSquid Project (c) 2004-2005 Sergey Erokhin aka ESL
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# detail see in gnugpl.txt

print "Content-Type: text/html\n\n";

use File::Basename;
push (@INC,(fileparse($0))[1]);

use CGI;
require "/etc/lightsquid/lightsquid.cfg";
require "/usr/share/lightsquid/common.pl";


$co=new CGI;
$year  =$co->param('year');
$month =$co->param('month');
$day   =$co->param('day');
$user  =$co->param('user');
$mode  =$co->param('mode');
$op    =$co->param('op');
$ip    =$co->param('ip');
$url   =$co->param('url');
$opmode=$co->param('opmode');

# http://192.168.2.1/lightsquid/user_detail.cgi?year=2009&month=07&day=21&user=192.168.2.3
# $year="2009";
# $month="07";
# $day="21";
# $user="192.168.2.3";

InitTPL("user_detail",$co->param('tpl'));

if      ($mode eq "month") {
  $workperiod="##MSG_WHOLE## ##MSG_MONTH## - $year $MonthName[$month]";
  $mask = "$year$month";
} elsif ($mode eq "year") {
  $workperiod="##MSG_WHOLE## ##MSG_YEAR## - $year";
  $mask = "$year";
} else {
  $workperiod="$day $MonthName[$month] $year";
  $mask = "$year$month$day";
  $mode = "day"
}

@datelist=sort glob "$reportpath/$mask*";

$calculatedtotal=0;
foreach $workday (sort @datelist) {
  GetRealName($workday,"?"); 
  GetGroup($workday);
  
  open FF,"<$workday/$user" || MyDie("can't open $daypath/$user");
  $totalsize=<FF>;chomp $totalsize;$totalsize=~s/total: //;

  while (<FF>) {
    ($site,$size,$hit,$h0,$h1,$h2,$h3,$h4,$h5,$h6,$h7,$h8,$h9,$h10,$h11,$h12,$h13,$h14,$h15,$h16,$h17,$h18,$h19,$h20,$h21,$h22,$h23,$name,$urlip,$lanip)=split;
    $namesite{$site}=($name eq "")?$site:$name;
    $ipsite{$site}=($urlip ne "NONE")?$urlip:"";
    $iplan{$site}=($lanip ne "NONE")?$lanip:"";
    $h{$site}{hit} +=$hit;
    $h{$site}{size}+=$size;
    $calculatedtotal+=$size;
  }  
  close FF;
}


#---------
# check - exist current user in .bigfiles
# only in DAY mode
if ($mode eq "day") {
  open FF,"<$reportpath/$year$month$day/.bigfiles";

  while (<FF>) {
    ($buser,$btime,$bsize,$blink)=split;
    $flagbigfiles=1 if ($buser eq $user);
  }	     
  close FF;
}  

if ($flagbigfiles) {
    $bigfiles_B="##MSG_BIG_FILES_USER##";
    $bigfiles_L=URLEncode("../bigfiles.cgi?year=$year&month=$month&day=$day&user=$user&mode=$mode");
}
#---------


#check for administrators mode
($secl, $minl, $hourl, $dayl, $monthl, $yearl) = (localtime);
$date=sprintf("%02d:%02d:%02d %02d.%02d.%04d", $hourl, $minl, $secl, $dayl, $monthl+1, $yearl+1900);
# print "<b>Debug:</b> <font color='RED'>op=$op opmode=$opmode ip=$ip url=$url</font><br>";
$needipcmd=0;
$needurlcmd=0;
if($op eq "add") {
  if(($opmode eq "both")||($opmode eq "ip")) {
    if($ip ne "") {
      addbadfile($badip,"$ip\t# $url added by lightsquid at $date\n");
      $needipcmd=1;
    }
  }
  if(($opmode eq "both")||($opmode eq "url")) {
    if($url ne "") {
      addbadfile($badurl,"$url\t# added by lightsquid at $date\n");
      $needurlcmd=1;
    }
  }
}

if($op eq "del") {
  if(($opmode eq "both")||($opmode eq "ip"))  {
    if($ip ne "") {
      delbadfile($badip,$ip);
      $needipcmd=1;
    }
  } 
  if(($opmode eq "both")||($opmode eq "url")) {
    if($url ne "") {
      delbadfile($badurl,$url);
      $needurlcmd=1;
    }
  }
}

startcmd($cmdip ) if($needipcmd);
startcmd($cmdurl) if($needurlcmd);

readbadfile($badip, "lbadip", "Nbadip" );
readbadfile($badurl,"lbadurl","Nbadurl");

#print "<b>Debug:</b> <font color='RED'>Nbadip=$Nbadip Nbadurl=$Nbadurl</font><br>";

#$max=$Nbadip;
#$max=$Nbadurl if($max<$Nbadurl);
#for($i=0; $i<$max; $i++) {
#  print "<b>Debug:</b> <font color='RED'>lbadip[$i]=$lbadip[$i] lbadurl[$i]=$lbadurl[$i]</font><br>";
#}

$N=0;
$total=0;
foreach $site (sort {$h{$b}{size} <=> $h{$a}{size}} keys %h)  {
  $N++;
  $hit=$h{$site}{hit};
  $size=$h{$site}{size};
  $total+=$size;
  $percent   =sprintf("%2.1f",int($size*1000/$calculatedtotal)/10);
  $printhit  =FineDec($hit,"M");
  $printsize =FineDec($size,"B");
  $printtotal=FineDec($total,"B");

  $siteurl_L=URLEncode("http://$namesite{$site}");
  $siteurl_B="$site";

  $rowattr = ($N & 1)?$hTPLVARIABLE{oddattr}:$hTPLVARIABLE{evenattr};
  
  $match=0;
  for($i=0; $i<$Nbadip; $i++) {
    $match|=1 if($lbadip[$i] eq $ipsite{$site});
  }

  for($i=0; $i<$Nbadurl; $i++) {
    $match|=2 if($lbadurl[$i] eq $namesite{$site});
  }

  #print "<b>Debug:</b> <font color='RED'>match=$match</font><br>";

  $adddel="";
  # $adddel.=$match;
  $adddel.='<A title="##ADDBOTHCOM## '.$badurl.' ##ADDBOTHCOMAND## '.$badip.'" HREF="'.URLEncode("user_detail.cgi?op=add&year=$year&month=$month&day=$day&user=$user&mode=$mode&ip=$ipsite{$site}&url=$namesite{$site}&opmode=both").'">(++)</A>&nbsp;' if ((($match&3)==0) && ($ipsite{$site} ne ""));
  $adddel.='<A title="##DELBOTHCOM## '.$badurl.' ##ADDBOTHCOMAND## '.$badip.'" HREF="'.URLEncode("user_detail.cgi?op=del&year=$year&month=$month&day=$day&user=$user&mode=$mode&ip=$ipsite{$site}&url=$namesite{$site}&opmode=both").'">(--)</A>&nbsp;' if ((($match&3)==3) && ($ipsite{$site} ne ""));
  $adddel.='<A title="##ADDIPCOM## '.$badip.'"   HREF="'.URLEncode("user_detail.cgi?op=add&year=$year&month=$month&day=$day&user=$user&mode=$mode&ip=$ipsite{$site}&url=$namesite{$site}&opmode=ip").'">(I+)</A>&nbsp;' if ((($match&1)==0) && ($ipsite{$site} ne ""));
  $adddel.='<A title="##DELIPCOM## '.$badip.'"   HREF="'.URLEncode("user_detail.cgi?op=del&year=$year&month=$month&day=$day&user=$user&mode=$mode&ip=$ipsite{$site}&url=$namesite{$site}&opmode=ip").'">(I-)</A>&nbsp;' if ((($match&1)==1) && ($ipsite{$site} ne ""));
  $adddel.='<A title="##ADDURLCOM## '.$badurl.'"  HREF="'.URLEncode("user_detail.cgi?op=add&year=$year&month=$month&day=$day&user=$user&mode=$mode&url=$namesite{$site}&opmode=url").'">(U+)</A>&nbsp;' if (($match&2)==0);
  $adddel.='<A title="##DELURLCOM## '.$badurl.'"  HREF="'.URLEncode("user_detail.cgi?op=del&year=$year&month=$month&day=$day&user=$user&mode=$mode&url=$namesite{$site}&opmode=url").'">(U-)</A>&nbsp;' if (($match&2)==2);

  $tmp=$hTPL{site};
  $tmp=~ s/##NUM##/$N/g;
  $tmp=~ s/##SITEURL_L##/$siteurl_L/g;
  $tmp=~ s/##SITEURL_B##/$siteurl_B/g;
  $tmp=~ s/##SITECONNECT##/$printhit/g;
  $tmp=~ s/##SITEBYTES##/$printsize/g;
  $tmp=~ s/##SITETOTAL##/$printtotal/g;
  $tmp=~ s/##SITEPERCENT##/$percent/g;
  $tmp=~ s/##ROWATTR##/$rowattr/g;
  $tmp=~ s/##ADDDELBTN##/$adddel/g; 
  $tpl{site}.=$tmp;
}

$printtotalsize=FineDec($calculatedtotal,"B");
	
$printuser="$user";
$printuser .= " (".GetRealName("?",$user).")" if ($userealname != 0);
      
# http://192.168.2.1/lightsquid/user_detail.cgi?year=2009&month=07&day=21&user=192.168.2.3
$urladmin=URLEncode("../user_detail.cgi?year=$year&month=$month&day=$day&user=$user");

ReplaceTPL_URL(MODEURL,$urladmin,"##USERMODE##");
ReplaceTPL(TIMEURL_S,URLEncode("../get.cgi?png=datetime"));

ReplaceTPL(USER,$printuser);
ReplaceTPL(TOTAL,$printtotalsize);
ReplaceTPL(WORKPERIOD,$workperiod);

ReplaceTPL(GROUP,(defined $hGroup{$user})?"$hGroupName{$hGroup{$user}}":"?");
#no URLEncode here! # sign in url !!
$usergroupurl_L="../group_detail.cgi?year=$year&month=$month&day=$day#$hGroup{$user}";
ReplaceTPL(USERGROUPURL_L,$usergroupurl_L);

ReplaceTPL_URL(TIMEURL,URLEncode("user_time.cgi?year=$year&month=$month&day=$day&user=$user","##MSG_TIME_LINK##"));
ReplaceTPL(USERTIME,$user);

ReplaceTPL_URL(BIGFILESURL,$bigfiles_L,$bigfiles_B);
ReplaceTPL(MSG_HEADER_URL,"../index.cgi");

ApplyTPL();
HideTPL("timereport") if (($timereport == 0) || ($mode ne "day"));
HideTPL("group")      if ($showgrouplink == 0);
PrintTPL();

__END__
2004-11-09 ADD : Total column, commulative total
2004-12-18 ADD : Показываем дату и имя пользователя в скрипте
2005-01-31 ADD : New Param (month=1) if, then show whole month user report, else only selected day
2005-04-14 FIX : in CONNECT column displayed size column
2005-04-17 ADD : TemplateEngine
2005-04-25 ADD : mode=year
2005-05-01 ADD : time report link
2005-08-30 ADD : Color Flipper
2005-09-08 ADD : if user exist in .bigfiles file, on top of report MESSAGE with link
2005-10-02 ADD : _L,_B
2005-11-01 ADD : Group name in header
2006-06-28 ADD : die -> MyDie
2006-06-28 ADD : &tpl= support
2006-09-13 ADD : add &user= in bigfiles URL
2006-11-20 ADD : /g for ##SITEURL_B## & ##SITEURL_L##, my need in some cases
2009-07-26 ADD :: add administrators mode

