#!/usr/bin/perl
#
# LightSquid Project (c) 2004-2005 Sergey Erokhin aka ESL
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# detail see in gnugpl.txt

print "Content-Type: text/html\n\n";

use File::Basename;
push (@INC,(fileparse($0))[1]);

use CGI;
require "/etc/lightsquid/lightsquid.cfg";
require "/usr/share/lightsquid/common.pl";


$co=new CGI;

$year =$co->param('year');
$month=$co->param('month');
$day  =$co->param('day');
$user =$co->param('user');
$mode =$co->param('mode');
$op    =$co->param('op');
$ip    =$co->param('ip');
$url   =$co->param('url');
$opmode=$co->param('opmode');
InitTPL("user_time",$co->param('tpl'));

if      ($mode eq "month") {
  $workperiod="##MSG_WHOLE## ##MSG_MONTH## - $year $MonthName[$month]";
  $mask = "$year$month";
} elsif ($mode eq "year") {
  $workperiod="##MSG_WHOLE## ##MSG_YEAR## - $year";
  $mask = "$year";
} else {
  $workperiod="$day $MonthName[$month] $year";
  $mask = "$year$month$day";
}

#@datelist=sort glob "$reportpath/$mask*";
@datelist=glob "$reportpath/$mask*";

$calculatedtotal=0;
foreach $workday (sort @datelist) {
  GetRealName($workday,"?");
  open FF,"<$workday/$user" || MyDie("can't open $workday/$user");
  $totalsize=<FF>;chomp $totalsize;$totalsize=~s/total: //;

  while (<FF>) {
    ($site,$size,$hit,@hlog)=split;
    $h{$site}{hit}  +=$hit;
    $h{$site}{size} +=$size;
    $calculatedtotal+=$size;

    for ($h=0;$h<24;$h++) {
      ($ttime,$tsize)=split /-/,$hlog[$h];
      $hsitetime{$site}[$h]+=$tsize;
      $htime[$h]+=$ttime;
      $hsize[$h]+=$tsize;
    }
    $name=$hlog[$h++];
    $namesite{$site}=($name eq "")?$site:$name;
    $urlip=$hlog[$h++];
    $ipsite{$site}=($urlip ne "NONE")?$urlip:"";
    $lanip=$hlog[$h++];
    $iplan{$site}=($lanip ne "NONE")?$lanip:"";
  }
  close FF;
}

# http://192.168.2.1/lightsquid/user_time.cgi?year=2009&month=07&day=24&user=192.168.2.3
$urladmin=URLEncode("../user_time.cgi?year=$year&month=$month&day=$day&user=$user&mode=$mode");
ReplaceTPL_URL(MODEURL,$urladmin,"##USERMODE##");

$tmp=$hTPL{site};
$tmp=~s/##URL##/align="right">##MSG_TOTAL##/;
$tmp=~s/##NUM##//;
$tmp=~s/##ROWATTR##/$hTPLVARIABLE{totalattr}/;

$HH="00";
$total=0;
for ($h=0;$h<24;$h++) {
  $size = sprintf("%.1f",$hsize[$h]/(1024*1024));
  $size = "." if (0 == $hsize[$h]);
  $total+=$hsize[$h];
  $tmp=~s/##T$HH##/$size/;
  $HH++;
}

$printsize =FineDec($total,"B");
$tmp=~s/##URLSIZE##/$printsize/;
$tpl{site}.=$tmp;

$tmptotal=$tmp;

#check for administrators mode
($secl, $minl, $hourl, $dayl, $monthl, $yearl) = (localtime);
$date=sprintf("%02d:%02d:%02d %02d.%02d.%04d", $hourl, $minl, $secl, $dayl, $monthl+1, $yearl+1900);
# print "<b>Debug:</b> <font color='RED'>op=$op opmode=$opmode ip=$ip url=$url</font><br>";
$needipcmd=0;
$needurlcmd=0;
if($op eq "add") {
  if(($opmode eq "both")||($opmode eq "ip")) {
    if($ip ne "") {
      addbadfile($badip,"$ip\t# $url added by lightsquid at $date\n");
      $needipcmd=1;
    }
  }

  if(($opmode eq "both")||($opmode eq "url")) {
    if($url ne "") {
      addbadfile($badurl,"$url\t# added by lightsquid at $date\n");
      $needurlcmd=1;
    }
  }
}

if($op eq "del") {
  if(($opmode eq "both")||($opmode eq "ip"))  {
    if($ip ne "") {
      delbadfile($badip,$ip);
      $needipcmd=1;
    }
  }

  if(($opmode eq "both")||($opmode eq "url")) {
    if($url ne "") {
      delbadfile($badurl,$url);
      $needurlcmd=1;
    }
  }
}

startcmd($cmdip ) if($needipcmd);
startcmd($cmdurl) if($needurlcmd);

readbadfile($badip, "lbadip", "Nbadip" );
readbadfile($badurl,"lbadurl","Nbadurl");

$N=0;
$Color=0;
$total=0;

foreach $site (sort {$h{$b}{size} <=> $h{$a}{size}} keys %h)  {
  $N++;
  $HH="00";
  $size=$h{$site}{size};

  next if ($N > $usertimelimit);

  $printsize =FineDec($size,"B");

  $tmp=$hTPL{site};
  $adddel='align="left">';

  $match=0;
  for($i=0; $i<$Nbadip; $i++) {
    $match|=1 if($lbadip[$i] eq $ipsite{$site});
  }

  for($i=0; $i<$Nbadurl; $i++) {
    $match|=2 if($lbadurl[$i] eq $namesite{$site});
  }

  # $adddel.=$match;
  $adddel.='<A title="##ADDBOTHCOM## '.$badurl.' ##ADDBOTHCOMAND## '.$badip.'" HREF="'.URLEncode("user_time.cgi?op=add&year=$year&month=$month&day=$day&user=$user&mode=$mode&ip=$ipsite{$site}&url=$namesite{$site}&opmode=both").'">(++)</A>&nbsp;' if ((($match&3)==0) && ($ipsite{$site} ne ""));
  $adddel.='<A title="##DELBOTHCOM## '.$badurl.' ##ADDBOTHCOMAND## '.$badip.'" HREF="'.URLEncode("user_time.cgi?op=del&year=$year&month=$month&day=$day&user=$user&mode=$mode&ip=$ipsite{$site}&url=$namesite{$site}&opmode=both").'">(--)</A>&nbsp;' if ((($match&3)==3) && ($ipsite{$site} ne ""));
  $adddel.='<A title="##ADDIPCOM## '.$badip.'"   HREF="'.URLEncode("user_time.cgi?op=add&year=$year&month=$month&day=$day&user=$user&mode=$mode&ip=$ipsite{$site}&url=$namesite{$site}&opmode=ip").'">(I+)</A>&nbsp;' if ((($match&1)==0) && ($ipsite{$site} ne ""));
  $adddel.='<A title="##DELIPCOM## '.$badip.'"   HREF="'.URLEncode("user_time.cgi?op=del&year=$year&month=$month&day=$day&user=$user&mode=$mode&ip=$ipsite{$site}&url=$namesite{$site}&opmode=ip").'">(I-)</A>&nbsp;' if ((($match&1)==1) && ($ipsite{$site} ne ""));
  $adddel.='<A title="##ADDURLCOM## '.$badurl.'"  HREF="'.URLEncode("user_time.cgi?op=add&year=$year&month=$month&day=$day&user=$user&mode=$mode&url=$namesite{$site}&opmode=url").'">(U+)</A>&nbsp;' if (($match&2)==0);
  $adddel.='<A title="##DELURLCOM## '.$badurl.'"  HREF="'.URLEncode("user_time.cgi?op=del&year=$year&month=$month&day=$day&user=$user&mode=$mode&url=$namesite{$site}&opmode=url").'">(U-)</A>&nbsp;' if (($match&2)==2);
  $adddel.='<A HREF="http://'.$namesite{$site}.'">'.$site.'</A></td>';

  $tmp=~s/##URL##/$adddel/;
  #<td align="left">##ADDDELBTN##<A HREF="##SITEURL_L##">##SITEURL_B##</A></td>
  for ($h=0;$h<24;$h++) {
    $size = sprintf("%.1f",$hsitetime{$site}[$h]/(1024*1024));
    $size = "." if (0 == $hsitetime{$site}[$h]);
    $tmp=~s/##T$HH##/$size/;
    $HH++;
  }

  $rowattr = (++$Color & 1)?$hTPLVARIABLE{oddattr}:$hTPLVARIABLE{evenattr};

  $tmp=~s/##NUM##/$N/;
  $tmp=~s/##URLSIZE##/$printsize/;
  $tmp=~s/##ROWATTR##/$rowattr/;
  $tpl{site} .= $tmp;
}

if ($N > $usertimelimit) {
  $HH="00";
  $tmp=$hTPL{site};
  $tmp=~s/##URL##/\.\.\./;
  $ttt="...";
  for ($h=0;$h<24;$h++) {
    $tmp=~s/##T$HH##/$ttt/;
    $HH++;
  }

  $rowattr = (++$Color & 1)?$hTPLVARIABLE{oddattr}:$hTPLVARIABLE{evenattr};

  $tmp=~s/##NUM##/\.\.\./;
  $tmp=~s/##URLSIZE##/\.\.\./;
  $tmp=~s/##ROWATTR##/$rowattr/;
  $tpl{site} .= $tmp;

  $printsize =FineDec($size,"B");
  $HH="00";
  $tmp=$hTPL{site};
  $tmp=~s/##URL##/$site/;
  for ($h=0;$h<24;$h++) {
    $size = sprintf("%.1f",$hsitetime{$site}[$h]/(1024*1024));
    $size = "." if (0 == $hsitetime{$site}[$h]);
    $tmp=~s/##T$HH##/$size/;
    $HH++;
  }

  $rowattr = (++$Color & 1)?$hTPLVARIABLE{oddattr}:$hTPLVARIABLE{evenattr};

  $tmp=~s/##NUM##/$N/;
  $tmp=~s/##URLSIZE##/$printsize/;
  $tmp=~s/##ROWATTR##/$rowattr/;
  $tpl{site} .= $tmp;
}

$tpl{site} .= $tmptotal;

$printtotalsize=FineDec($calculatedtotal,"B");

$printuser="$user";
$printuser .= " (".GetRealName("?",$user).")" if ($userealname != 0);

ReplaceTPL(USER,$printuser);
ReplaceTPL(WORKPERIOD,$workperiod);
ReplaceTPL(MSG_HEADER_URL,"../index.cgi");

ApplyTPL();
print $template;

__END__
2005-05-01 ADD : Initial release
2005-08-30 ADD : Color flipper, total also at bottom of page
2005-09-07 FIX : Color flipper, if records > $usertimelimit
2005-10-02 ADD : _L,_B
2006-06-28 ADD : die -> MyDie
2006-06-28 ADD : &tpl= support
2009-07-26 ADD :: add administrators mode

