#!/usr/bin/perl
#
# LightSquid Project (c) 2004-2005 Sergey Erokhin aka ESL
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# detail see in gnugpl.txt

use File::Basename;
push( @INC, ( fileparse($0) )[1] );

require "/etc/lightsquid/lightsquid.cfg";
require "/usr/share/lightsquid/common.pl";

if (!eval { require GD }) {
	print "Content-Type: text/html\n\n";
	MyDie("LightSquid can't show graphics report ...<br>GD-GRAPH library is unavailable, please install it or set \$graphreport=0 in lightsquid.cfg for disable graphics ...")
}

use GD;

use CGI;
use CGI::Carp qw (fatalsToBrowser);

$co = new CGI;

$year  = $co->param('year');
$month = $co->param('month');
$user  = $co->param('user');
$mode  = $co->param('mode');
$png   = $co->param('png');

$imagesizex=800;
$imagesizey=400;
$heighttitlex=13;
$heighttitley=13;
$scalexx=10;
$scalexy=10;
$scaleyx=43;
$scaleyy=10;
$borderleft=5;
$borderright=20;
$borderdown=5;
$borderup=5;
$deepx=7;
$deepy=5;
$labelx=4;
$labely=5;
$sizeofbarx=11;
$sizeofbary=5;
$sizeofbarspacex=5;
$numberofdays=31;
$minimagesizex=($numberofdays+1)*($sizeofbarspacex+$sizeofbarx+$deepx)+$scaleyx+$heighttitley+$borderleft+$borderright+$labely;
$imagesizex=$minimagesizex;
$linebarbox=10;
$sizeofboxx=20;
$sizeofboxy=10;
$plotareaoy=$imagesizey-1-$scalexy-1.5*$heighttitlex-$labelx-$borderdown;
$plotareay=$plotareaoy-$borderup-$deepy;
$plotareaox=$scaleyx+$heighttitley+$labely+$borderleft;
$plotareax=$imagesizex-1-$plotareaox-$borderright;

$debugscale=0;
# http://192.168.2.1/lightsquid/graph.cgi?year=2009&month=07&mode=month
#$year="2009";
#$month="02";
#$mode="month";
#$png=1;
#
#http://192.168.2.1/lightsquid/graph.cgi?year=2009&month=08&mode=user&user=192.168.2.5
#http://192.168.2.1/lightsquid/graph.cgi?year=2009&month=07&mode=user&user=192.168.2.1
$year="2009"        if(1==$debugscale);
$month="08"         if(1==$debugscale);
$mode="user"        if(1==$debugscale);
$user="192.168.2.5" if(1==$debugscale);
$png=1              if(1==$debugscale);

my @MAP;

sub GetY($) {
    my $value=shift;
    if($automax < $value ) { $value = $automax; }
    my $y=$plotareaoy-($value-$automin)*($plotareay-$linebarbox-$sizeofboxy)/($automax-$automin);
    return int($y);
} ## end sub GetY($)

sub GetX($) {
    my $value=shift;
    my $X=($value-0.5)*($sizeofbarspacex+$sizeofbarx+$deepx)+$plotareaox;
    return int($X);
} ## end sub GetX($)

sub bar($$) {
    my $day   = shift;
    my $value = shift;

    $value=1 if($value==0);
    $maxaverage+=$value;
    $maxaverageday++;

    my $barx=GetX($day);
    my $bary=GetY($value);

    my $barx2=$barx+$sizeofbarx;
    my $bary2=$plotareaoy;
    # add data for MAP structure
    if ($png==0) {
	my $mapx1=$barx;
	my $mapx2=$barx2+$deepx;
	my $mapy1=$bary-$linebarbox-$sizeofboxy+$deepy/2;
	my $mapy2=$bary2+$deepy;
	$MAP[$day]="$mapx1,$mapy1,$mapx2,$mapy2";
        $maxcntr++ if($value>$max);
	return;
    }

    #$im->rectangle($barx,$bary-$linebarbox-$sizeofboxy,$barx2+$deepx,$bary2+$deepy,$black);

    $im->filledRectangle($barx,$bary+$deepy,$barx2,$bary2+$deepy,$bcolor3); # main BAR

    my $poly1 = new GD::Polygon; # top 3d polygon
    $poly1->addPt($barx+$deepx,            $bary       );
    $poly1->addPt($barx,                   $bary+$deepy);
    $poly1->addPt($barx+$sizeofbarx,       $bary+$deepy);
    $poly1->addPt($barx+$sizeofbarx+$deepx,$bary       );
    $im->filledPolygon($poly1,$bcolor1);

    my $poly2 = new GD::Polygon; # right 3d BAR
    $poly2->addPt($barx+$sizeofbarx+$deepx,$bary        );
    $poly2->addPt($barx+$sizeofbarx,       $bary+$deepy );
    $poly2->addPt($barx+$sizeofbarx,       $bary2+$deepy);
    $poly2->addPt($barx+$sizeofbarx+$deepx,$bary2       );
    $im->filledPolygon( $poly2, $bcolor2 );

    #text box
    if($value<$automax) { $textcolor=$dimgray; $boxcolor=$goldenrod; }
    else { $textcolor = $white; $boxcolor = $red; }

    my $lineboxx=$barx+($sizeofbarx+$deepx)/2;
    $im->line($lineboxx,$bary+$sizeofbary/2,$lineboxx,$bary-$linebarbox+$sizeofbary/2,$dimgray);
    $im->filledRectangle($lineboxx-$sizeofboxx/2,$bary-$linebarbox+$sizeofbary/2-$sizeofboxy,$lineboxx+$sizeofboxx/2,$bary-$linebarbox+$sizeofbary/2,$boxcolor);
    $im->rectangle($lineboxx-$sizeofboxx/2,$bary-$linebarbox+$sizeofbary/2,$lineboxx+$sizeofboxx/2,$bary-$linebarbox+$sizeofbary/2-$sizeofboxy,$goldenrod2);
    $im->string(gdTinyFont,$lineboxx-$sizeofboxx/2+1,$bary-$linebarbox+$sizeofbary/2-$sizeofboxy+1,fixnum($value,3,"b"),$textcolor);
    undef $poly1;
    undef $poly2;
} ## end sub bar($$)

sub InitGraph() {

    # allocate some colors
    $white      = $im->colorAllocate( 255, 255, 255 );
    $red        = $im->colorAllocate( 255,   0,   0 );
    $lavender   = $im->colorAllocate( 230, 230, 250 );
    $white      = $im->colorAllocate( 255, 255, 255 );
    $gray       = $im->colorAllocate( 192, 192, 192 );
    $silver     = $im->colorAllocate( 211, 211, 211 );
    $black      = $im->colorAllocate(   0,   0,   0 );
    $blue       = $im->colorAllocate(  35,  35, 227 );
    $dimgray    = $im->colorAllocate( 105, 105, 105 );
    $dimgray2   = $im->colorAllocate( 170, 170, 170 );
    $darkblue   = $im->colorAllocate(   0,   0, 139 );
    $goldenrod  = $im->colorAllocate( 234, 234, 174 );
    $goldenrod2 = $im->colorAllocate( 207, 181,  59 );

    %colors = (
	blue 	=> [ [  62,  80, 167 ], [  40,  51, 101 ], [  57,  73, 150 ] ],
	green	=> [ [ 120, 166, 129 ], [  84, 113,  82 ], [ 158, 223, 167 ] ],
	yellow	=> [ [ 185, 185,  10 ], [ 111, 111,  10 ], [ 166, 166,  10 ] ],
	brown	=> [ [  97,  45,  27 ], [  60,  30,  20 ], [  88,  41,  26 ] ],
	red	=> [ [ 185,  10,  10 ], [ 111,  10,  10 ], [ 166,  10,  10 ] ],
	orange	=> [ [ 255, 233, 142 ], [ 220, 163,  72 ], [ 255, 198, 107 ] ],
    );

    ${bcolor.$_} = $im->colorAllocate( @{ $colors{$barcolor}[$_-1] } ) for (1..3);

    $im->rectangle(0,0,$imagesizex-1,$imagesizey-1,$dimgray); # border
    $im->filledRectangle($plotareaox,$plotareaoy-$plotareay,$plotareaox+$plotareax,$plotareaoy,$silver); # main area
    $im->rectangle($plotareaox,$plotareaoy,$plotareaox+$plotareax,$plotareaoy-$plotareay,$black);
    my $tmp=$all/($automax-$automin);

    $poly1 = new GD::Polygon; # left 3d border
    $poly1->addPt($plotareaox,       $plotareaoy                  );
    $poly1->addPt($plotareaox-$deepx,$plotareaoy+$deepy           );
    $poly1->addPt($plotareaox-$deepx,$plotareaoy-$plotareay+$deepy);
    $poly1->addPt($plotareaox,       $plotareaoy-$plotareay       );
    $im->filledPolygon($poly1,$gray);

    $im->line($plotareaox,       $plotareaoy,                  $plotareaox-$deepx,$plotareaoy+$deepy,           $black);      #black outer
    $im->line($plotareaox-$deepx,$plotareaoy+$deepy,           $plotareaox-$deepx,$plotareaoy-$plotareay+$deepy,$black);
    $im->line($plotareaox-$deepx,$plotareaoy-$plotareay+$deepy,$plotareaox,       $plotareaoy-$plotareay,       $black);
    $im->line($plotareaox,       $plotareaoy-$plotareay,       $plotareaox,       $plotareaoy,                  $black);

    $poly2 = new GD::Polygon; # down 3d border
    $poly2->addPt($plotareaox,                  $plotareaoy       );
    $poly2->addPt($plotareaox+$plotareax,       $plotareaoy       );
    $poly2->addPt($plotareaox+$plotareax-$deepx,$plotareaoy+$deepy);
    $poly2->addPt($plotareaox-$deepx,           $plotareaoy+$deepy);
    $im->filledPolygon($poly2,$gray);

    $im->line($plotareaox,                  $plotareaoy,$plotareaox+$plotareax,       $plotareaoy,       $black); # black outer
    $im->line($plotareaox+$plotareax,       $plotareaoy,$plotareaox+$plotareax-$deepx,$plotareaoy+$deepy,$black);
    $im->line($plotareaox+$plotareax-$deepx,$plotareaoy+$deepy,$plotareaox-$deepx,    $plotareaoy+$deepy,$black);
    $im->line($plotareaox-$deepx,           $plotareaoy+$deepy,$plotareaox,           $plotareaoy,       $black);

    #bottom border grid
    #for ( $x = 70 ; $x <= 680 ; $x += 20 ) { $im->line( $x, $mmaxy + 5, $x, $mmaxy + 8, $dimgray ); }

    #print days
    $weekday=GetWeekDayDate("$year$month"."01");
    my $day;
    for ($day=1; $day<=31; $day++) {
	my $gridx=GetX($day);
        $im->line($gridx+$sizeofbarx/2,$plotareaoy+$deepy,$gridx+$sizeofbarx/2,$plotareaoy+$labelx+$deepy,$dimgray);
        $color=$dimgray;
        $color=$red if($weekday==0);
	$color=$red if(($weekday==6)&&($weekendmode eq "both"));
	$weekday++;
	$weekday=0 if($weekday==7);
        $im->string( gdSmallFont,$gridx,$plotareaoy+$labelx+$deepy,sprintf("%02d",$day),$color);
    } ## end for ( $i = 1 ; $i <= 31...


  for($v=$automin; $v<=$automax; $v+=$autostep/2) {
    $y=GetY($v);
    $im->line($plotareaox,               $y,       $plotareaox+$plotareax,$y,       $dimgray2);
    $im->line($plotareaox,               $y,       $plotareaox-$deepx,    $y+$deepy,$dimgray2);
    $im->line($plotareaox-$labely-$deepx,$y+$deepy,$plotareaox-$deepx,    $y+$deepy,$dimgray2);
  }

  for($v=$automin; $v<=$automax; $v+=$autostep) {
    $y=GetY($v);
    $im->line($plotareaox,               $y,       $plotareaox+$plotareax,$y,       $dimgray);
    $im->line($plotareaox,               $y,       $plotareaox-$deepx,    $y+$deepy,$dimgray);
    $im->line($plotareaox-$labely-$deepx,$y+$deepy,$plotareaox-$deepx,    $y+$deepy,$dimgray);
    $im->string(gdSmallFont,$heighttitley+$borderleft,$y-1,fixnum($v,3,$prepow),$dimgray);
  }

  #axis name
  $im->stringUp(gdLargeFont,$borderleft,$plotareaoy-$plotareay/2,"BYTES",$dimgray);
  $im->stringUp(gdLargeFont,$borderleft,$plotareaoy-$plotareay/2+1,"BYTES",$dimgray);
  $im->string(gdLargeFont,$plotareaox+$plotareax/2,$plotareaoy+$labelx+$deepy+$heighttitlex,"DAYS",$dimgray);
  $im->string(gdLargeFont,$plotareaox+$plotareax/2+1,$plotareaoy+$labelx+$deepy+$heighttitlex,"DAYS",$dimgray);
} ## end sub InitGraph($$$)


####################################################################################

if ( $mode eq "user" )  { $max = $graphmaxuser; $varname="graphmaxuser";}
if ( $mode eq "month" ) { $max = $graphmaxall;  $varname="graphmaxall";}

$average = 0;
$days    = 0;
$automin = 0;
$automax = 0;

#$max=1 if ($max == 0); #div0 protection
$filter  = "$year$month";
@daylist = glob("$reportpath/$filter*");
foreach $daypath ( sort @daylist ) {
  open FF, "<$daypath/.total";
  $tmp  = <FF>;
  $size = <FF>;
  chomp $size;
  $size    =~ s/^size: //;
  $daypath =~ m/(\d\d\d\d)(\d\d)(\d\d)/;
  if ( $mode eq "month" ) {
    # bar( $3, $size );
    $bars{$3}=$size;
    $average += $size;
  }
  elsif ( $mode eq "user" ) {
    while (<FF>) {
      ( $user_, $size, $hit ) = split;
      if ( $user_ eq $user ) {
      # bar( $3, $size );
      $bars{$3}=$size;
      $average += $size;
      }
    }
  } ## end elsif ( $mode eq "user" )
  $days++;
  close FF;
} ## end foreach $daypath ( sort @daylist)

if(0==$max) {
  while(($bday,$bytes)=each(%bars)) {
    $automin=$bytes if($automin==0);
    $automax=$bytes if($automax==0);
    $automin=$bytes if($automin>$bytes);
    $automax=$bytes if($automax<$bytes);
  }
  if($automin==$automax) {
    $automax=1000 if(0==$automax);
    $automin=0;
  }
} else {
    $automin=0;
    $automax=$max;
}

  $numberoflines=10;
  $base=10;
  #$automax=1001*1024**3;
  #$automin=0;

  $autostep=$automax-$automin;
  $automax=$numberoflines*2**10+$automin if($autostep<$numberoflines*2**10);
  $autostep=$automax-$automin;
  $autostep=1 if($autostep==0);
  $autostep/=($numberoflines);
  $prepow=int(log($autostep)/log(2**10));
  $prepow++ if($automax/(2**10)**$prepow>$base**3-1);
  $autostep/=(2**10)**$prepow;
  $pow=int(log($autostep)/log($base));
  $step=$autostep/$base**$pow;
  if   ($step<=0.1) {$step=0.1;}
  elsif($step<=0.2) {$step=0.2;}
  elsif($step<=0.5) {$step=0.5;}
  elsif($step<=1) {$step=1;}
  elsif($step<=2) {$step=2;}
  elsif($step<=5) {$step=5;}
  else {$step=10;};
  $autostep=$step*$base**$pow*(2**10)**$prepow;
  $automin1=int($automin/$autostep)*$autostep;
  $automax1=int($automax/$autostep)*$autostep;
  if($automin1>$automin) {
    $automin=int($automin/$autostep-1)*$autostep;
  } else {
    $automin=$automin1;
  };

  if($automax1<$automax) {
    $automax=int($automax/$autostep+1)*$autostep;
  } else {
    $automax=$automax1;
  }

  if(1==$debugscale) { for($v=$automin; $v<=$automax; $v+=$autostep) { printf fixnum($v,3,$prepow)."\n"; }; };
  exit if(1==$debugscale);

if ( $png == 1 ) {
    print "Content-type: image/png\n\n";
    # create a new image
    $im = new GD::Image($imagesizex,$imagesizey);
    InitGraph();
} else {
    print "Content-Type: text/html\n\n";

    InitTPL("graph",$co->param('tpl'));
    $workperiod = "$MonthName[$month] $year";
    ReplaceTPL( WORKPERIOD, $workperiod );

    $graphicsurl = "graph.cgi?png=1\&year=$year\&month=$month\&mode=$mode";
    $graphicsurl .= "\&user=$user" if ( $mode eq "user" );
    ReplaceTPL( GRAPHICSURL, URLEncode($graphicsurl) );

    if ( $mode eq "month" ) {
        $txtmode = "##MSG_WHOLE## ##MSG_MONTH##";
    }
    else {
        $txtmode = "##MSG_USER## \"$user\"";
    }
    ReplaceTPL( MODE, $txtmode );
}

while (($bday,$bytes)=each(%bars)) {
  bar($bday,$bytes);
}



if ( $png == 1 ) {

    #average bar
    if ($days>0) {
      $average/=$days;
      $y=GetY($average);
      $im->filledRectangle($heighttitley+$borderleft,$y,$plotareaox-$labely-$deepx,$y+$scaleyy,$white);
      $im->line($plotareaox,               $y,       $plotareaox+$plotareax,$y,       $red);
      $im->line($plotareaox,               $y,       $plotareaox-$deepx,    $y+$deepy,$red);
      $im->line($plotareaox-$labely-$deepx,$y+$deepy,$plotareaox-$deepx,    $y+$deepy,$red);
      $im->string(gdSmallFont,$heighttitley+$borderleft,$y-1,fixnum($average,3,"B"),$red);
      #  $y = GetY( int( $average / $days ) );
      #  $im->line( 60, $y, 700, $y, $red );
      #  $im->line( 56, $y + 2, 60, $y, $red );

    } ## end if ( $days > 0 )

    binmode STDOUT;

    # Convert the image to PNG and print it on standard output
	print eval {$im->png} || $im->gif; #use gif if png not supported by libgd (Konstantin M. Mefodichev)

} ## end if ( $png == 1 )
else {

    $url=($mode eq "user")?"user_detail.cgi":"day_detail.cgi";
    $url.=qq(?year=$year&month=$month);
    $url.=($mode eq "user")?"\&user=$user":"";
    $url = URLEncode($url);

    $day="00";
    for ($i=1;$i<$#MAP+1;$i++) {
	$day++;
	$tmp=$hTPL{imagemap};
        $tmp=~s/##MAPURL##/$url\&day=$day/;
        $tmp=~s/##MAPCOORD##/$MAP[$i]/;
	$tpl{imagemap}.=$tmp;
    }

    ReplaceTPL( IMGMAP, $imgmap );

    $maxaverage /= ($maxaverageday+1);
      ReplaceTPL( VARVALUE,sprintf("%1.2f",int(($maxaverage+($maxaverage*0.30))/(1024*1024*1024/10)+1)/10));
      ReplaceTPL( VARNAME,$varname);
    ReplaceTPL(MSG_HEADER_URL,"index.cgi");
    HideTPL("warning") if(($maxcntr < 7)||(0==$max));

    ApplyTPL();
    PrintTPL();

} ## end else [ if ( $png == 1 )

__END__
2005-11-07 ADD : some HW perl trick
2005-11-07 ADD : url encode
2006-06-28 ADD : &tpl= support
2006-09-05 ADD : warning and recomended max value
2006-09-13 ADD : error to browser
2006-11-23 ADD : FIX recomendation warning
2008-11-28 FIX : try to use gif if png not supported by libgd
               : div0 protection added
2008-12-14 FIX : No more err500 in browser if no GD is installed
           ADD : Terabyte support ;)
